/* More examples that violate the 'new' constraints */

/* Borrowed from question 3 test cases for the Advanced Topics assignement */

/* Below are some predicates that test the correctness of the code
   we provided above, for the question 3. */


test111 :-
	new([_, [
		sname(['Alice']),
		cname(['Cooper']),
		age([61]),
		numbers([1,2,3,4,5,6])
	    ]]) => student.

test222 :-
	new([_, [
		sname(['Alice1']),
		cname(['Cooper1']),
		age([61]),
		numbers([2,3])
	    ]]) => person.


/* Try to create two persons, while there is the constraint:
   there is only one person */
test :-
	new([_, [
		sname(['Alice']),
		cname(['Cooper']),
		age([61]),
		numbers([1,2,3])
	    ]]) => person,

	new([_, [
		sname(['Rob']),
		cname(['Halford']),
		age([66])
	    ]]) => person,

	new([_, [
		sname(['Robert']),
		cname(['Belladonna']),
		age([69])
	    ]]) => person.

test_new :-
	new([Id, [
		sname(['Nick']),
		cname(['Gerro'])
	    ]]) => person,

	put_age([65]) => Id.



%% Create a student that violates the year constraint.
test1(student1) :-
	new([Id, [
		sname(['Alice']),
		cname(['Cooper']),
		year([2])
	    ]]) => student,

	 update_year([2,7]) => Id.


test1(student2) :-
	new([Id, [
		sname(['Rob']),
		cname(['Halford']),
		year([2]),
		age([17])
	    ]]) => student.

%%	put_age([17]) => Id.


%% Create a student that violates both age and year constraints.
test1(student3) :- 
	new([Id, [
		sname(['Eric']),
		cname(['Adams']),
		year([1]),
		age([16])
	    ]]) => student.




%% Create a student that violates no constraint.
test1(student4) :- 
	new([Id, [
		sname(['Gary']),
		cname(['Moore']),
		year([2]),
		age([15])
	    ]]) => student.



%% I try to create a PGRA with year slot equal to 10.
test1(pgra) :- 
    new([_,[
	cname(['Eric']),
        sname(['Clapton']),
        subject(['guitar']),
        year([10])
        ]]) => pgra.

test1(postgrad) :- 
    new([Id,[
        cname(['Bruce']),
        sname(['Dickinson']),
        phone([1111]),
	age([55])
        ]]) => lecturer,

    new([_,[
	cname(['Jeff']),
        sname(['Healey']),
        subject(['guitar']),
        year([1]),
	supervisor([Id])
        ]]) => postgrad.

test2(postgrad) :- 
    new([Id1,[
	cname(['Jeff']),
        sname(['Healey']),
	age([65])
%%        subject(['guitar']),
%%        year([1])
        ]]) => ra,

    new([Id2,[
	cname(['Jeff1']),
        sname(['Healey1']),
        subject(['guitar']),
        year([1]),
	age([30])
        ]]) => pgra,

    new([Id3,[
	cname(['Jeff2']),
        sname(['Healey3']),
        subject(['guitar']),
        year([1]),
	age([27])
        ]]) => pgra,


    new([Id4,[
        cname(['Bruce']),
        sname(['Dickinson']),
        phone([1111]),
	age([55]),
	supervises([Id2,Id3])
        ]]) => lecturer,

	put_supervises([Id1]) => Id4.

%%	put_project(['MLT']) => Id2.



%% I try to create one member of the staff with the same phone number
%% with a lecturer.
test(lecturer) :-
    new([_,[
        cname(['Bruce']),
        sname(['Dickinson']),
        phone([1111])
        ]]) => lecturer,

    new([Id,[
        cname(['Dave']),
        sname(['Murray']),
        subject(['vocals']),
        year([2])
        ]]) => pgra,

        put_phone([1111]) => Id.



%% I try to create a new RA with the same phone number with two other
%% members of the staff (another RA and a PGRA).
test(ra) :-
    new([_,[
        cname(['Steve']),
        sname(['Harris']),
        phone([2222])
        ]]) => ra,

    new([_,[
        cname(['Adrian']),
        sname(['Smith']),
        phone([2222])
%%        subject(['guitar']),
%%        year([2])
        ]]) => ra,

    new([_,[
        cname(['Paul']),
        sname(['Dianno']),
        phone([2222])
        ]]) => ra,

    new([_,[
        cname(['Ozzy']),
        sname(['Osbourne']),
        phone([2222])
        ]]) => ra.
%%	put_phone([2222]) => ID.

%% I try to create four PGRA's with the same phone number.
test(pgra) :-
    new([_,[
        cname(['Ozzy']),
        sname(['Osbourne']),
        phone([3333]),
        subject(['vocals']),
        year([3])
        ]]) => pgra,

    new([_,[
        cname(['Ronny']),
        sname(['Dio']),
        phone([3333]),
        subject(['vocals']),
        year([2])
        ]]) => pgra,

    new([_,[
        cname(['Tonny']),
        sname(['Iomi']),
        phone([3333]),
        subject(['guitar']),
        year([4])
        ]]) => pgra,

    new([_,[
        cname(['John']),
        sname(['Demayo']),
        phone([3333]),
        subject(['bass']),
        year([1])
        ]]) => pgra.

test(pgra1) :-
    new([_,[
        cname(['Ozzy']),
        sname(['Osbourne']),
        phone([1111]),
        subject(['vocals']),
        year([3])
        ]]) => pgra,

    new([_,[
        cname(['Ronny']),
        sname(['Dio']),
        phone([2222]),
        subject(['vocals']),
        year([2])
        ]]) => pgra,

    new([_,[
        cname(['Tonny']),
        sname(['Iomi']),
        phone([3333]),
        subject(['guitar']),
        year([4])
        ]]) => pgra,

    new([_,[
        cname(['John']),
        sname(['Demayo']),
        phone([4444]),
        subject(['bass']),
        year([1])
        ]]) => pgra.

test10 :-
	new([ID, [
		sname(['Alice']),
		cname(['Cooper'])
	    ]]) => person,
	put_age([40]) => ID.

test_constraint :- 
	put_constraint(['forall s in student year of s > 0 and year of s < 6']) => student.


vcc :- 

	new([Tutor,[
		cname(['Ozzy']),
        	sname(['Osbourne']),
        	phone([1111]),
		research_interest(['singing'])
		]]) => staff,

	new([RA,[
		sname(['Alice']),
		cname(['Cooper']),
		age([35]),
		tutor([Tutor])
		]]) => ra,

	new([Lecturer,[
        	cname(['John']),
        	sname(['Demayo']),
        	research_interest(['bass']),
		ra([RA])
		]]) => lecturer.

