/* overrider.pl */

/* This file includes some predicate definitions
   that override pre-existing predicates of ADAM.
   It also includes operator definitions and some
   very primitive predicates.  This file should be
   consulted first of all 
*/


%%% Operator definitions
:- op(950,xfy,>>>), op(700,xfx,<>).

%%% ECLiPSe directive to disable error messages when
%%% a predicate does not exist
:- set_error_handler(68,fail/0).

% Nick Bassiliades addition 10/2/95
% 'assertz' does not exist in ECLiPSe

assertz(Clause) :- assert(Clause).



%%% If A then B else true
A >>> B :- 
	A -> B ; true.

%%% highest_super(+Class,-High)
%%% it returns the highest superclass of Class
highest_super(A,B) :-
    path(A,C),
    (C==[colan_object,object] ->
        B=A;
        reverse(C,[_,_,B|_])).
