% Set up a database for people/university data


u1d :- new([udb1, [
             storage_system([triple]),
	     db([u1]),
	     is_a([keyed_class_mixin]),
	     slot(slot_tuple(is_a, system, set, optional, object)),
	     slot(slot_tuple(
	                slot_desc, system, set, optional, slot_desc_tuple)),
	     slot(slot_tuple(key_desc, global, single, optional, plog))
	 ]]) => keyed_meta_class.

u1m :- new([udb1, [
	     is_a([keyed_class_mixin]),
	     slot(slot_tuple(is_a, system, set, optional, object)),
	     slot(slot_tuple(
	                slot_desc, system, set, optional, slot_desc_tuple)),
	     slot(slot_tuple(key_desc, global, single, optional, plog)),
	     method((delete(global,[],[],[],[]) :- 
			write('I am here!'), nl
	     	)),
	     method((replace_method(global,[],[plog],[],M) :- 
		message_recipient(Class),
		write('Replacing method: '), nl,
		write(M), nl,
		write('For class: '),
		write(Class), nl,
		replace_method(M) => super
		))
	 ]]) => keyed_meta_class.

/*u2 :- new([course, [
             slot(slot_tuple(code, global, single, total, string)),
	     slot(slot_tuple(level, global, single, optional, integer)),
	     key([code])
	 ]]) => udb1.*/

u3 :- new([person, [
             slot(slot_tuple(cname, global, single, total, string)),
	     slot(slot_tuple(sname, global, single, total, string)),
	     slot(slot_tuple(age, global, single, optional, integer)),
	     key([sname, cname])
	 ]]) => udb1.

u4 :- new([staff, [
             is_a([person]),
	     slot(slot_tuple(phone, global, single, optional, integer))
	 ]]) => udb1.

u5 :- new([ra, [
             is_a([staff])
	 ]]) => udb1.

u6 :- new([lecturer, [
             is_a([staff])
	 ]]) => udb1.

u7 :- new([student, [
             is_a([person]),
	     slot(slot_tuple(year, global, single, total, integer))
	 ]]) => udb1.

u8 :- new([undergrad, [
             is_a([student])
	 ]]) => udb1.

u9 :- new([postgrad, [
             is_a([student]),
	     slot(slot_tuple(subject, global, single, total, string))
	 ]]) => udb1.

u10 :- new([pgra, [
             is_a([postgrad, ra]),
	     slot(slot_tuple(percentra, global, single, optional, integer))
	 ]]) => udb1.

/*u11 :- new([tcl, [
             slot(slot_tuple(lecturer, global, single, total, lecturer)),
	     slot(slot_tuple(course, global, single, total, course)),
	     slot(slot_tuple(section, global, single, total, string)),
	     key([lecturer, course, section])
	 ]]) => udb1.*/



% Declare the schema as a disk-based database.  This routine creates
% the database and loads the schema into it, leaving the database open
% for writing so that data may be loaded in.
%
% Once the database is created it can be closed using:   adam_close(Db)
% and opened using:                                      adam_open(Db, Mode)
% where Db is the name of the database (u1 in this example) and
% Mode is one of 'read' or 'write'.

declare_disk_schema :-
	create_triple_store(u1),
	u1d, u2, u3, u4,
	u5, u6, u7, u8,
	u9, u10, u11.


% Declare the schema as an in-memory database.

declare_schema :-
	u1m, /*u2, */u3, u4,
	u5, u6, u7, u8,
	u9, u10/*, u11*/.

:- declare_schema.
/*:- [auxiliary,examples].*/
