/* schema1.pl */

/* Example schema for university */



/*u2 :- new([course, [
             slot(slot_tuple(code, global, single, total, string)),
	     slot(slot_tuple(level, global, single, optional, integer)),
	     key([code])
	 ]]) => colan_class.*/




u3 :- new([person, [
             slot(slot_tuple(cname, global, single, total, string)),
	     slot(slot_tuple(sname, global, single, total, string)),
	     slot(slot_tuple(age, global, single, optional, integer)),
	     slot(slot_tuple(loves, global, set, optional, person)),
	     constraints([/*'forall p in person age of p < 60'
			  'forall p in person
				1 in numbers of p'
			  'not exists p in person
				age of p =< 30 or age of p >= 50',
			  'exist exactly 3 p in person
				such that age of p > 60'*/]),
	     key([sname, cname])
	 ]]) => colan_class.


u4 :- new([staff, [
		is_a([person]),
		slot(slot_tuple(research_interest, global, single, optional, string)),
		slot(slot_tuple(phone, global, single, optional, integer)),
		constraints([/*'exist at most 50 s in staff'
			     'forall s in staff
				age of s < 60',
			     'not exists s in staff
				such that age of s >= 60'*/])
	 ]]) => colan_class.


u5 :- new([ra, [
             is_a([staff]),
	     slot(slot_tuple(projects, global, set, optional, string)),
	     slot(slot_tuple(tutor, global, single, optional, staff)),
	     constraints([/*'forall r in ra
		    		exist exactly 2 r1 in ra
		    			such that phone of r = phone of r1'*/])
	 ]]) => colan_class.


u6 :- new([lecturer, [
             is_a([staff]),
	     slot(slot_tuple(ra, global, set, optional, ra)),
	     slot(slot_tuple(projects, global, set, optional, string)),
	     constraints([/*
			 'forall l in lecturer
				projects of l = projects of supervises of l'
			 'forall l in lecturer
				not exists s in supervises of l
					such that projects of l <> projects of s'
			'forall l in lecturer
				not exists r in research_assistant of l
					such that research_interest of l =
							research_interest of tutor of r',


			  'forall l in lecturer
				not exists l1 in research_assistant of l
					such that age of l =< age of l1'
			  'forall l in lecturer
				exists s in supervises of l
					such that age of l > age of s',
			  'exists l in lecturer
				such that supervises of l = l',
			  'forall l in lecturer
				not exists p in postgrad
					such that phone of l = phone of p'*/])
	 ]]) => colan_class.


u7 :- new([student, [
             is_a([person]),
	     slot(slot_tuple(year, global, single, total, integer)),
	     constraints([/*'forall e in student
				age of e + year of e >= 10000'
			  'forall s in student
				exist at most 1 s1 in student
					such that age of s + year of s1 < 20',
			  'forall s in student 
				year of s > 0 and year of s < 6',
			  'forall s in student
				year of s < age of s'*/])
	 ]]) => colan_class.


u8 :- new([undergrad, [
             is_a([student])
	 ]]) => colan_class.


u9 :- new([postgrad, [
             is_a([student]),
	     slot(slot_tuple(subject, global, single, total, string)),
	     slot(slot_tuple(supervisor, global, single, optional, lecturer)),
	     constraints([/*'exist at most 10 p in postgrad',
			  'forall p in postgrad
				age of supervised_by of p < 50'*/])
	 ]]) => colan_class.


u10 :- new([pgra, [
             is_a([postgrad, ra]),
	     slot(slot_tuple(percentra, global, single, optional, integer)),
	     constraints([/*'forall p in pgra
				exist at least 2 p1 in pgra
					such that phone of p = phone of p1',
			  'forall p in pgra
				year of p =< 4'*/])
	 ]]) => colan_class.


%% Declare the schema as an in-memory database.
declare_schema :-
	/*u2,*/ u3, u4,
	u5, u6, u7, u8,
	u9, u10.

:- /*spy create_compound_function, spy create_method*/ declare_schema.
